//**********************************************************************
//  goodsamp.cxx   -   Tiny sample of use of aipGood.h
//
//  This program illustrates the use of goodness, importance and
//  likelihood.
//
//  See copyright and license information at end of this file.
//
//  99/04/04  Brian Marshall  development begun
//  99/05/29  Brian Marshall  completion of program
//
//
//----------------------------------------------------------------------

#include <iostream.h>
#include "aipGood.h"

//======================================================================
//
//         Being able to sleep until 7:00 am is 'Quite-Good'.  
//         Being able to catch the news at 7:15 is 'Good', 
//         but this is only 'Slightly-Important'.  If I set 
//         the alarm for 7:00, it is 'Fairly-Unlikely' that 
//         I will be late for work, which would be 'Bad' 
//         and 'Very-Important'.

 
int main (int argc, char *argv[]) {

  aipGoodness g_sleep_to_7 = aipQuiteGood;
  
  aipGoodness g_715_news = aipGood;
  aipImportance i_715_news = aipSlightlyImportant;
  g_715_news *= i_715_news;             // Apply the importance.

  aipGoodness g_late_for_work = aipBad * aipVeryImportant;
  g_late_for_work *= aipFairlyUnLikely;

  aipGoodness g_up_at_7 = g_sleep_to_7 + g_715_news + g_late_for_work;

  cout << "Getting up at seven is "
       << g_up_at_7.description() << ".\n";

  return 0;

}


//======================================================================

//   Copyright Brian Marshall 1999
//
//   Permission is hereby granted, free of charge, to any 
//   person obtaining a copy of this software and associated 
//   documentation files (the "Software"), to deal in the Software 
//   without restriction, including without limitation the rights 
//   to use, copy, modify, merge, publish, distribute, sublicense, 
//   and/or sell copies of the Software, and to permit persons to 
//   whom the Software is furnished to do so, subject to the 
//   following conditions:
//
//   The above copyright notice and this permission notice shall be
//   included in all copies or substantial portions of the Software.
//
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
//   NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
//   OTHER DEALINGS IN THE SOFTWARE.
//
//
//**********************************************************************







