//**********************************************************************
//  picfirst.h   -   Sample implementation of strategy
//                   to solve dirty-hard problems.
//
//  This file declares  PickFirst  which is a subclass of dhStrategy.
//
//  This is a sample strategy.  It is a pretty bad strategy.  It 
//  picks the first option in each decision.  It is an example of how
//  to implement a strategy. >>  Do not expect it to be successful.  << 
//
//  Copyright Brian Marshall 1999
//
//  See the license at end of this file.
//
//  Brian Marshall    bmarshal@agt.net    (403)651-0584
//
//  99/05/21  Brian Marshall  development begun.
//
//----------------------------------------------------------------------

#ifndef picfirst_h_guard
#define picfirst_h_guard

#include "dirthard.h"


//======================================================================
//  Aspects.


class pfProbAspect : public dhAspect { 
};


class pfDcsnAspect : public dhAspect { 
};


class pfOptAspect : public dhAspect { 
};


class pfSbjAspect : public dhAspect { 
};


//======================================================================
//  PickFirst   -   A (poor) strategy for solving dirty-hard problems.


class PickFirst : public dhStrategy {

protected:

  virtual dhAspect  * create_problem_aspect  (void);
  virtual dhAspect  * create_decision_aspect (void);
  virtual dhAspect  * create_option_aspect   (void);
  virtual dhAspect  * create_subject_aspect  (void);

public:

  PickFirst (void);
  virtual ~PickFirst (void);

  virtual bool  solve  (dhDecision *x);
  virtual bool  solve  (dhProblem  *x);

};


//======================================================================

#endif


//----------------------------------------------------------------------
//                           License
//
//   Permission is hereby granted, free of charge, to any 
//   person obtaining a copy of this software and associated 
//   documentation files (the "Software"), to deal in the Software 
//   without restriction, including without limitation the rights 
//   to use, copy, modify, merge, publish, distribute, sublicense, 
//   and/or sell copies of the Software, and to permit persons to 
//   whom the Software is furnished to do so, subject to the 
//   following conditions:
//
//   The copyright notice and this license shall be included in all 
//   copies or substantial portions of the Software.
//
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
//   NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
//   OTHER DEALINGS IN THE SOFTWARE.
//
//**********************************************************************

